'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _constant = require('./constant');

var arrayPrototype = Array.prototype;
var objectPrototype = Object.prototype;

if (!arrayPrototype.forEach) {
	arrayPrototype.forEach = function (callback) {
		var _this = this;

		_jquery2['default'].each(this, function (i, value) {
			return callback(value, i, _this);
		});
	};
}

if (!Object.create) {
	Object.create = function (proto) {
		var Fn = function Fn() {};
		Fn.prototype = proto;
		return new Fn();
	};
}

if (!Object.keys) {
	Object.keys = function (obj) {
		var keys = [];
		_jquery2['default'].each(obj, function (key) {
			return keys.push(key);
		});
		return keys;
	};
}

if (!Function.prototype.bind) {
	Function.prototype.bind = function (context) {
		var _this2 = this;

		for (var _len = arguments.length, initArgs = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
			initArgs[_key - 1] = arguments[_key];
		}

		return function () {
			for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
				args[_key2] = arguments[_key2];
			}

			return _this2.apply(context, initArgs.concat(args));
		};
	};
}

var setAttr = function setAttr(elem, key, value) {
	_jquery2['default'].fn.attr.call([elem], key, value);
};

exports.setAttr = setAttr;
var getAttr = function getAttr(elem, key) {
	return _jquery2['default'].fn.attr.call([elem], key);
};

exports.getAttr = getAttr;
var removeAttr = function removeAttr(elem, key) {
	_jquery2['default'].fn.removeAttr.call([elem], key);
};

exports.removeAttr = removeAttr;
var querySelectorAll = function querySelectorAll(elem, selector) {
	return _jquery2['default'](selector, elem);
};

exports.querySelectorAll = querySelectorAll;
var setEvent = function setEvent(elem, key, value) {
	if (!isFn(value)) {
		return;
	}
	key = key.toLowerCase();
	var $elem = _jquery2['default'](elem);
	var eventName = key.substr(2) + '.react';
	$elem.off(eventName);
	$elem.on(eventName, value);
	if (key !== 'onchange') {
		return;
	}
	if ('oninput' in elem) {
		$elem.off('oninput.onchange');
		$elem.on('oninput.onchange', value);
		return;
	}
	elem.onpropertychange = function (e) {
		if (e.propertyName === 'value') {
			$elem.trigger(eventName);
		}
	};
};

exports.setEvent = setEvent;
var removeEvent = function removeEvent(elem, key) {
	key = key.toLowerCase();
	var $elem = _jquery2['default'](elem);
	var eventName = key.substr(2) + '.react';
	$elem.off(eventName);
	if (key !== 'onchange') {
		return;
	}
	if ('oninput' in elem) {
		$elem.off('oninput.onchange');
		return;
	}
	elem.onpropertychange = null;
};

exports.removeEvent = removeEvent;
var toArray = Array.from || function (obj) {
	try {
		return Array.prototype.slice.call(obj);
	} catch (e) {
		var list = [];
		for (var i = 0, len = obj.length; i < len; i++) {
			list.push(obj[i]);
		}
		return list;
	}
};

exports.toArray = toArray;
//types.js
var isType = function isType(type) {
	return function (obj) {
		return obj != null && Object.prototype.toString.call(obj) === '[object ' + type + ']';
	};
};
exports.isType = isType;
var isObj = isType('Object');
exports.isObj = isObj;
var isStr = isType('String');
exports.isStr = isStr;
var isNum = isType('Number');
exports.isNum = isNum;
var isFn = isType('Function');
exports.isFn = isFn;
var isBln = isType('Boolean');
exports.isBln = isBln;
var isArr = Array.isArray || isType('Array');
exports.isArr = isArr;
var isComponent = function isComponent(obj) {
	return isFn(obj);
};
exports.isComponent = isComponent;
var isComponentClass = function isComponentClass(obj) {
	return isFn(obj) && isFn(obj.prototype.render);
};
exports.isComponentClass = isComponentClass;
var isUndefined = function isUndefined(obj) {
	return obj === undefined;
};
exports.isUndefined = isUndefined;
var pipe = function pipe(fn1, fn2) {
	return function () {
		for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
			args[_key3] = arguments[_key3];
		}

		fn1.apply(this, args);
		return fn2.apply(this, args);
	};
};

exports.pipe = pipe;
var nextFrame = isFn(window.requestAnimationFrame) ? function (fn) {
	return requestAnimationFrame(fn);
} : function (fn) {
	return setTimeout(fn, 100 / 6);
};

exports.nextFrame = nextFrame;
var getUid = function getUid() {
	return Math.random().toString(36).substr(2);
};

exports.getUid = getUid;
var mergeProps = function mergeProps(props, children) {
	if (children && children.length) {
		children = children.length === 1 ? children[0] : children;
		if (props) {
			props.children = children;
		} else {
			props = { children: children };
		}
	}
	return props;
};

exports.mergeProps = mergeProps;
var mapChildren = function mapChildren(children, callback) {
	var record = arguments[2] === undefined ? { index: 0, store: [] } : arguments[2];
	var store = record.store;

	children.forEach(function (child) {
		if (isArr(child)) {
			mapChildren(child, callback, record);
		} else if (!isBln(child)) {
			store.push(child);
			callback(child, record.index);
			record.index += 1;
		}
	});
	return store;
};

exports.mapChildren = mapChildren;
var hasKey = function hasKey(obj) {
	return obj && obj.props && obj.props.key;
};

exports.hasKey = hasKey;
var $events = {};

var $on = function $on(name, callback) {
	var events = $events[name] = $events[name] || [];
	events.push(callback);
};

exports.$on = $on;
var $trigger = function $trigger(name) {
	for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
		args[_key4 - 1] = arguments[_key4];
	}

	if (isArr($events[name])) {
		$events[name].forEach(function (callback) {
			return callback.apply(undefined, args);
		});
	}
};

exports.$trigger = $trigger;
var $triggerOnce = function $triggerOnce(name) {
	for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
		args[_key5 - 1] = arguments[_key5];
	}

	var events = $events[name];
	$events[name] = [];
	if (isArr(events)) {
		events.forEach(function (callback) {
			return callback.apply(undefined, args);
		});
	}
};

exports.$triggerOnce = $triggerOnce;
var componentId = undefined;
var $componentId = undefined;
var setComponentId = function setComponentId(id) {
	$componentId = componentId;
	componentId = id;
};
exports.setComponentId = setComponentId;
var resetComponentId = function resetComponentId() {
	componentId = $componentId;
};

exports.resetComponentId = resetComponentId;
var refsStore = {};
var getDOMNode = function getDOMNode() {
	return this;
};
var getRefs = function getRefs(id) {
	var refs = refsStore[id] || {};
	delete refsStore[id];
	return refs;
};
exports.getRefs = getRefs;
var collectRef = function collectRef(key, value) {
	if (!componentId) {
		return;
	}
	var refs = refsStore[componentId];
	if (!refs) {
		refs = refsStore[componentId] = {};
	}
	if (value.nodeName) {
		value.getDOMNode = getDOMNode;
	}
	refs[key] = value;
};

exports.collectRef = collectRef;
var appendChild = function appendChild(node, child) {
	node.appendChild(child);
};

exports.appendChild = appendChild;
var removeChild = function removeChild(node, child) {
	$trigger(_constant.WILL_UNMOUNT, child);
	node.removeChild(child);
};

exports.removeChild = removeChild;
var replaceChild = function replaceChild(node, newChild, child) {
	$trigger(_constant.WILL_UNMOUNT, child);
	node.replaceChild(newChild, child);
};

exports.replaceChild = replaceChild;
var setProp = function setProp(elem, key, value) {
	switch (true) {
		case key === 'key':
			break;
		case key === 'ref':
			if (value) {
				collectRef(value, elem);
			}
			break;
		case key === 'style':
			setStyle(elem, value);
			break;
		case isEventKey(key):
			setEvent(elem, key, value);
			break;
		case key in elem:
			elem[key] = value;
			break;
		case key === 'dangerouslySetInnerHTML':
			if (elem.innerHTML !== value.__html) {
				elem.innerHTML = value.__html;
			}
			break;
		default:
			elem.setAttribute(key, value);
	}
};

exports.setProp = setProp;
var setProps = function setProps(elem, props) {
	Object.keys(props).forEach(function (key) {
		return setProp(elem, key, props[key]);
	});
};

exports.setProps = setProps;
var isEventKey = function isEventKey(key) {
	return /^on/.test(key);
};

exports.isEventKey = isEventKey;
var removeProp = function removeProp(elem, key) {
	switch (true) {
		case isEventKey(key):
			removeEvent(elem, key);
			break;
		case !(key in elem):
			removeAttr(elem, key);
			break;
		case isFn(elem[key]):
			elem[key] = null;
			break;
		case isStr(elem[key]):
			elem[key] = '';
			break;
		case isBln(elem[key]):
			elem[key] = false;
			break;
		default:
			try {
				elem[key] = null;
			} catch (e) {}
	}
};

exports.removeProp = removeProp;
var patchProps = function patchProps(node, props, newProps) {
	if (!props && newProps) {
		return setProps(node, newProps);
	} else if (!newProps && props) {
		return Object.keys(props).each(function (key) {
			if (key === 'style') {
				removeStyle(node, props[key]);
			} else {
				removeProp(node, key);
			}
		});
	}

	for (var key in newProps) {
		if (!newProps.hasOwnProperty(key)) {
			continue;
		}
		var _newValue = newProps[key];
		if (key === 'style') {
			patchStyle(props.style, newProps.style);
		} else if (isUndefined(_newValue)) {
			removeProp(node, key);
		} else if (_newValue !== props[key]) {
			setProp(node, key, _newValue);
		} else if (key === 'ref' && _newValue) {
			collectRef(_newValue, node);
		}
		delete props[key];
	}

	for (var key in props) {
		if (!props.hasOwnProperty(key)) {
			continue;
		}
		if (isUndefined(newValue[key])) {
			removeProp(node, key);
		}
	}
};

exports.patchProps = patchProps;
var removeStyle = function removeStyle(elem, style) {
	if (!isObj(style)) {
		return;
	}
	Object.keys(style).forEach(function (key) {
		return elem.style[key] = '';
	});
};

exports.removeStyle = removeStyle;
var setStyle = function setStyle(elem, style) {
	if (!isObj(style)) {
		return;
	}
	Object.keys(style).forEach(function (key) {
		setStyleValue(elem.style, key, style[key]);
	});
};

exports.setStyle = setStyle;
var patchStyle = function patchStyle(elem, style, newStyle) {
	if (!newStyle && style) {
		removeStyle(elem, style);
	} else if (newStyle && !style) {
		setStyle(elem, newStyle);
	} else {
		(function () {
			var domStyle = elem.style;
			Object.keys(_extends({}, style, newStyle)).forEach(function (key) {
				var value = newStyle[key];
				if (isUndefined(value)) {
					domStyle[key] = '';
				} else if (value !== style[key]) {
					setStyleValue(domStyle, key, value);
				}
			});
		})();
	}
};

exports.patchStyle = patchStyle;
var isUnitlessNumber = {
	animationIterationCount: true,
	boxFlex: true,
	boxFlexGroup: true,
	boxOrdinalGroup: true,
	columnCount: true,
	flex: true,
	flexGrow: true,
	flexPositive: true,
	flexShrink: true,
	flexNegative: true,
	flexOrder: true,
	fontWeight: true,
	lineClamp: true,
	lineHeight: true,
	opacity: true,
	order: true,
	orphans: true,
	tabSize: true,
	widows: true,
	zIndex: true,
	zoom: true,

	// SVG-related properties
	fillOpacity: true,
	stopOpacity: true,
	strokeDashoffset: true,
	strokeOpacity: true,
	strokeWidth: true
};

/**
 * @param {string} prefix vendor-specific prefix, eg: Webkit
 * @param {string} key style name, eg: transitionDuration
 * @return {string} style name prefixed with `prefix`, properly camelCased, eg:
 * WebkitTransitionDuration
 */
var prefixKey = function prefixKey(prefix, key) {
	return prefix + key.charAt(0).toUpperCase() + key.substring(1);
};

/**
 * Support style names that may come passed in prefixed by adding permutations
 * of vendor prefixes.
 */
var prefixes = ['Webkit', 'ms', 'Moz', 'O'];

// Using Object.keys here, or else the vanilla for-in loop makes IE8 go into an
// infinite loop, because it iterates over the newly added props too.
Object.keys(isUnitlessNumber).forEach(function (prop) {
	return prefixes.forEach(function (prefix) {
		return isUnitlessNumber[prefixKey(prefix, prop)] = isUnitlessNumber[prop];
	});
});

var RE_NUMBER = /^-?\d+(\.\d+)?$/;
var setStyleValue = function setStyleValue(style, key, value) {
	if (RE_NUMBER.test(value) && !isUnitlessNumber[key]) {
		style[key] = value + 'px';
	} else {
		style[key] = value;
	}
};
exports.setStyleValue = setStyleValue;

//pass