'use strict';

exports.__esModule = true;

var _util = require('./util');

var _constant = require('./constant');

var widgetElems = [];

/**
* 根据 tagName props attrs 创建 real-dom
*/
var create = function create(_x) {
	var _again = true;

	_function: while (_again) {
		var vnode = _x;
		tagName = props = children = elem = undefined;
		_again = false;

		if (_util.isBln(vnode)) {
			return;
		}

		if (vnode == null) {
			return document.createElement('noscript');
		}

		if (_util.isStr(vnode) || _util.isNum(vnode)) {
			return document.createTextNode(vnode);
		}

		if (vnode.type === _constant.WIDGET) {
			return vnode.init();
		}

		var tagName = vnode.tagName;
		var props = vnode.props;
		var children = vnode.children;

		if (_util.isFn(tagName)) {
			props.children = children;
			vnode = tagName(props);
			_x = vnode;
			_again = true;
			continue _function;
		}

		if (tagName == null) {
			debugger;
		}
		var elem = document.createElement(tagName);
		if (_util.isObj(props)) {
			_util.setProps(elem, props);
		}
		if (children && children.length > 0) {
			children.forEach(function (child) {
				return addChild(elem, child);
			});
		}
		return elem;
	}
};

exports['default'] = create;
var addChild = function addChild(elem, child) {
	if (_util.isArr(child)) {
		return child.forEach(function (item) {
			return addChild(elem, item);
		});
	}
	var childNode = create(child);
	if (childNode !== undefined) {
		elem.appendChild(childNode);
	}
};
exports.addChild = addChild;