'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _component = require('../component');

var _util = require('./util');

var createElement = function createElement(tagName, props) {
	for (var _len = arguments.length, children = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
		children[_key - 2] = arguments[_key];
	}

	var isComponent = _util.isFn(tagName) && _util.isFn(tagName.prototype.render);
	if (isComponent) {
		return new _component.Widget(tagName, _extends({}, props, {
			children: children.length === 1 ? children[0] : children
		}));
	}
	return {
		tagName: tagName,
		props: props,
		children: children
	};
};

exports['default'] = createElement;
module.exports = exports['default'];